package com.dsic.gj_erp.service.zyjh;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.controller.zyjh.dto.ShangLiao;
import com.dsic.gj_erp.mapper.jhgk.DmYdjhMapper;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class ZyjhService extends ServiceImpl<DmYdjhMapper,DmYdjh> {

    public List<Map<String, Object>> gxjhwcqk(){
        DateTime date = DateUtil.lastMonth();
        String from= DateUtil.beginOfMonth(date).toString("yyyy/MM/dd");
        String to =DateUtil.endOfMonth(date).toString("yyyy/MM/dd");
        return baseMapper.gxjhwcqk(from,to);
    }

    public List<Map<String, Object>> gyfcl(){
        return baseMapper.gyfcl();
    }

    public List<Map<String, Object>> jhwcqk(){
        DateTime date = DateUtil.lastMonth();
        String from= DateUtil.beginOfMonth(date).toString("yyyy/MM/dd");
        String to =DateUtil.endOfMonth(date).toString("yyyy/MM/dd");
        return baseMapper.jhwcqk(from,to);
    }

    public Map<String,Object> gekuachaliang(){
        DateTime date = DateUtil.lastMonth();
        String from= DateUtil.beginOfMonth(date).toString("yyyy/MM/dd");
        String to =DateUtil.endOfMonth(date).toString("yyyy/MM/dd");
        return baseMapper.gekuachaliang(from,to,"11");
    }

    public void updateForSl(ShangLiao sl){
        String date=DateUtil.date().toString("yyyy/MM/dd");
        LambdaUpdateWrapper<DmYdjh> wrapper = Wrappers.<DmYdjh>lambdaUpdate()
                //上料
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getSlycldw()),DmYdjh::getSlycldw, sl.getYdjh().getSlycldw())
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getSlyclcs()),DmYdjh::getSlyclcs, sl.getYdjh().getSlyclcs())
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getSlfkry()),DmYdjh::getSlfkrq, date)
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getSlfkry()),DmYdjh::getSlfkry, sl.getYdjh().getSlfkry())

                //理料
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getLldw()),DmYdjh::getLldw, sl.getYdjh().getLldw())
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getLlcs()),DmYdjh::getLlcs, sl.getYdjh().getLlcs())
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getLlfkry()),DmYdjh::getLlfkrq, date)
                .set(ObjUtil.isNotEmpty(sl.getYdjh().getLlfkry()),DmYdjh::getLlfkry, sl.getYdjh().getLlfkry())
                .eq(DmYdjh::getId, sl.getYdjh().getId());

        switch (sl.getType()){
            case YCL:
                wrapper.set(DmYdjh::getZt, DmYdjh.getSlZt());
                break;
            case LLJ:
                wrapper.set(DmYdjh::getZt, DmYdjh.getLLZt());
        }


        this.update(wrapper);
    }
}
